<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\TransferioService;
use App\Http\Services\ItemtransferioService;
use App\Http\Validators\TransferioValidator;
use App\Http\Services\WorkflowService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\KapalService;
use App\Http\Services\VoyagesService;
use App\Http\Services\StokkapalService;
use App\Http\Services\ActivitylogService;

class TransferioController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $lokasiitem;
    private $itemtransferio;
    private $kapal;
    private $workflow;
    private $voyage;
    private $stokkapal;
    private $activityLog;

    /**
     * Transferio constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new TransferioService();
        $this->itemtransferio = new ItemtransferioService();
        $this->validator = new TransferioValidator();
        $this->lokasiitem = new LokasiitemService();
        $this->workflow = new WorkflowService();
        $this->kapal = new KapalService();
        $this->voyage = new VoyagesService();
        $this->stokkapal = new StokkapalService();
        $this->activityLog= new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $input = $request->all();
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $auth = json_decode($request->session()->get('auth'));

            // $input["refId"] = $input["ioNumber"] = $this->baseService->getLastestID("PELNI/IO " . date("y") . " " . $input["kodeKapal"]);   
            $input["refId"] = $input["ioNumber"] = $this->baseService->getLastestID("IO" . date("y") . $auth->orgId);
            $ID = $this->baseService->store($input);
            $this->itemtransferio->store($input);
            $this->workflow->store($input);

            $input["date"] = date("Y-m-d H:i:s");
            $input["username"] = $auth->username;
            $input["activity"] = "CREATE";
            $input["deskripsi"] = $auth->name . " just <b>created</b> new Transfer I/O <a href=\"" . url("administrator/transferio/" . $ID ) . "\">" . $input["refId"] . "</a>";
            $this->activityLog->store($input);
            
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/transferio")->with("successMessages", "Data sudah berhasil disimpan dengan No #" . $input["refId"]);
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "fromKapalId" => "fromKapalId"
            , "toKapalId" => "toKapalId"
            , "fromLocationId" => "fromLocationId"
            , "toLocationId" => "toLocationId"
            , "approverId" => "approverId"
            , "requesterId" => "requesterId"
            , "type" => "type"
        ];
        $this->data["criteria"] = [
            "ioNumber" => "No Transaksi"
            , "namaKapal" => "Organisasi Tujuan	"
            , "fromLocationId" => "Tgl Permintaan"
        ];

        $this->data["ordering"] = [
            "ioNumber:asc" => "No Transaksi &uarr;"
            , "ioNumber:desc" => "No Transaksi &darr;"
            , "toNamaKapal:asc" => "Organisasi Tujuan	&uarr;"
            , "toNamaKapal:desc" => "Organisasi Tujuan &darr;"
            , "expectedReceivedDate:asc" => "Tgl Permintaan &uarr;"
            , "expectedReceivedDate:desc" => "Tgl Permintaan &darr;"
        ];
        $this->data["kapals"] = $this->kapal->index();
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        $this->data["transferios"] = $this->baseService->paging($request);
        return view("modules.transferio.transferio_index", $this->data);
    }


    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Request $request)
    {
        $this->data["criteria"] = [            
            "deskripsi"     => "Deskripsi" ,
            "part_number"    => "Part Number",
            "namaItem"      => "Kode Item"
        ];
        $auth = json_decode($request->session()->get('auth'));
        $this->data["kapals"] = $this->kapal->getListNotIn([$auth->kapalId]);
        // $this->data["lokasiitems"] = $this->lokasiitem->index($request);
        // $this->data["voyages"] = $this->voyage->index();
        return view("modules.transferio.transferio_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {
        $this->data["transferio"] = $this->baseService->show($id);
        if($this->data["transferio"]) {
            $this->data["isApproval"] = false;
            $this->data["listItems"] = $this->itemtransferio->showBasedOnTransferIo($request, $this->data["transferio"]);
            return view("modules.transferio.transferio_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function approval(Request $request, $id)
    {
        $this->data["transferio"] = $this->baseService->show($id);
        if($this->data["transferio"]) {
            $this->data["isApproval"] = true;
            $this->data["listItems"] = $this->itemtransferio->showBasedOnTransferIo($request, $this->data["transferio"]);
            return view("modules.transferio.transferio_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    public function saveApproval(Request $request)
    {       
        $auth = json_decode($request->session()->get('auth'));
        $input = $request->all();
        $input["refId"] = $input["ioNumber"];
        $this->validator->beforeApprove($input);
        if ($this->validator->hasError())
            return $this->validator->validateView();

        $transaction = $this->baseService->showByTransactionNo($input["refId"]);
        if($transaction->status > 0) {
            return redirect()->back()->with("errMessage", "Status transaksi #" . $input["refId"] . " sudah tidak open lagi!");
        } else {
            DB::beginTransaction();
            try {
                $this->baseService->approve($input);
                $this->workflow->approve($input);

                if($input["status"] == 1) {
                    $staging["header"] = $transaction; // $this->baseService->showByTransactionNo($input["ioNumber"]);
                    $staging["footer"] = $input["items"] = $this->itemtransferio->showBasedOnTransferIo($request, $staging["header"]);

                    $stockHistory = [
                        "transaksi"     => "pindahbarangio",
                        "noTransaksi"   => $input["refId"],
                        "username"      => $auth->username,
                        "periode"       => $staging["header"]->tglTransaksi
                    ];
                    $this->stokkapal->reduceStock($input["items"], $stockHistory);
                    
                    $staging["auth"] = $auth;
                    $this->baseService->saveStaging($staging);
                }

                $input["date"] = date("Y-m-d H:i:s");
                $input["username"] = $auth->username;
                $input["activity"] = "APPROVAL";
                $input["namaTransaksi"] = "Workflow";
                $input["deskripsi"] = $auth->name . " just <b>approved</b> transaction Transaction IO <b>#" . $input["refId"] . "</b>";
                $this->activityLog->store($input);


                DB::commit();
                $this->sync();
                return redirect()->to("administrator/workflow")->with("successMessages", "Data dengan No #" . $input["refId"] . " sudah berhasil disimpan");
            } catch (\Exception $e) {
                DB::rollBack();
                throw new DefaultException($e->getMessage());
            }
        }
    }

    public function search(Request $request) {
        $data = $this->stokkapal->getStokList($request);
        echo json_encode($data); 
    }

    public function getKapalSubInv(Request $request) {
        $data = $this->lokasiitem->getKapalSubInv($request);
        echo json_encode($data); 
    }
}